// core
// ====
import * as types from './types';
function error(type, code, hideSource) {
    if (hideSource === void 0) { hideSource = false; }
    return {
        type: type,
        code: code,
        hideSource: hideSource,
    };
}
function tiError(code, hideSource) {
    if (hideSource === void 0) { hideSource = false; }
    return error(types.ti, code, hideSource);
}
export var DataTypeError = tiError('DATA TYPE');
export var SyntaxError = tiError('SYNTAX');
export var UndefinedError = tiError('UNDEFINED');
export var LabelError = tiError('LABEL');
export var ArgumentError = tiError('ARGUMENT');
export var DimMismatchError = tiError('DIM MISMATCH');
export var DivideByZeroError = tiError('DIVIDE BY 0');
export var InvalidDimError = tiError('INVALID DIM');
export var DomainError = tiError('DOMAIN');
export function libError(code, hideSource) {
    if (hideSource === void 0) { hideSource = false; }
    return error(types.lib, code, hideSource);
}
export var UnimplementedError = libError('unimplemented');
export function newMem() {
    return {
        vars: new Map(),
        ans: newFloat(),
    };
}
export function newFloat(value) {
    if (value === void 0) { value = 0; }
    return {
        type: types.NUMBER,
        resolved: true,
        float: value
    };
}
export var ONE = newFloat(1);
export var MINUSONE = newFloat(-1);
export function exhaustiveMatchingGuard(_) {
    throw new Error("Should not have reached here");
}
