// inject
// ===========
export var LOOPER = 'looper';
export var EVENT = 'event';
export var PERF = 'perf';
var map = new Map();
var callbackMap = new Map();
export function set(name, value) {
    map.set(name, value);
    var callbacks = callbackMap.get(name);
    if (callbacks !== undefined) {
        callbacks.forEach(function (callback) { return callback(value); });
    }
}
export function subscribe(name, callback) {
    var callbacks = callbackMap.get(name);
    if (callbacks === undefined) {
        callbacks = [];
        callbackMap.set(name, callbacks);
    }
    callbacks.push(callback);
    if (map.has(name)) {
        callback(map.get(name));
    }
}
export function unsubscribe(name, callback) {
    var callbacks = callbackMap.get(name);
    if (callbacks === undefined) {
        return;
    }
    var index = callbacks.indexOf(callback);
    if (index === -1) {
        return;
    }
    callbacks.splice(index, 1);
}
