// parser
// ======
import * as types from '../common/types';
// import {
//   parse as parseTiBasic,
//   SyntaxError,
// } from './tibasic.peggy';
import * as parser from './tibasic.peggy';
export function parse(source, options) {
    if (options === void 0) { options = {}; }
    if (source === undefined) {
        throw new Error('Undefined source!');
    }
    var sourceMap = options.sourceMap || 'inline';
    // TODO:
    // * Allow multiple statements per line with ':'
    var sourceLines = source.split(/\r?\n/);
    var parsedLines = sourceLines.map(function (s) {
        var parsedLine;
        try {
            parsedLine = parser.parse(s);
        }
        catch (error) {
            if (error instanceof parser.SyntaxError) {
                parsedLine = { type: 'SyntaxError' };
            }
            else {
                throw error;
            }
        }
        if (sourceMap === 'inline') {
            parsedLine.source = s;
        }
        return parsedLine;
    });
    return parsedLines;
}
export function parseExpression(source) {
    if (source === undefined) {
        throw new Error('Undefined source!');
    }
    var sourceLines = source.split(/\r?\n/);
    if (sourceLines.length > 1) {
        throw new Error('Too many lines for an expression');
    }
    var sourceLine = sourceLines[0];
    if (sourceLine === undefined) {
        throw new Error('Too few lines for an expression');
    }
    var parsedLine;
    try {
        parsedLine = parser.parse(sourceLine);
    }
    catch (error) {
        if (!(error instanceof SyntaxError)) {
            throw error;
        }
    }
    return parsedLine !== undefined && parsedLine.type === types.ValueStatement ? parsedLine.value : { type: 'SyntaxError' };
}
