// pegutil
// =======
import * as types from '../common/types';
function toBinary(left, rightOp) {
    return {
        type: types.BINARY,
        operator: Array.isArray(rightOp) ? rightOp[0] : '*',
        left: left,
        right: Array.isArray(rightOp) ? rightOp[1] : rightOp,
    };
}
export function buildBinaryExpression(head, tail) {
    return tail.reduce(toBinary, head);
}
export function buildImplicitBinaryExpression(head, tail, end) {
    var list = tail.flat();
    if (end !== null) {
        list.push(end);
    }
    return list.reduce(toBinary, head);
}
function toMenuChoice(element) {
    return {
        option: element[1],
        location: element[3],
    };
}
export function buildMenuStatement(title, options) {
    var choices = options.map(toMenuChoice);
    return {
        type: types.MenuStatement,
        title: title,
        choices: choices,
    };
}
export function buildList(head, tail) {
    return {
        type: types.LIST,
        elements: [head].concat(tail),
    };
}
